<?php
/* 
	+--------------------------------------------------+
	|Classe de abstrao - Verso para PHP4 - 3.0		|
	+--------------------------------------------------+
	|PostgreSQL														|
	|MySQL															|
	+--------------------------------------------------+
	|@autor   Juarez Gonalves Nery Junior					|
	|@email   jws_junior@yahoo.com.br						|
	|@HP      junior.t35.com									|
	|@data    Sex Dez 12 15:07:48 BRT 2003					|
	+--------------------------------------------------+
*/

DEFINE('DB_ERROR_CONNECT_PARAM','Erro na entrada de parmetros');
DEFINE('DB_ERROR_CONNECT','Erro ao conectar com base de dados');
DEFINE('DB_ERROR_QUERY','Erro ao executar query');
DEFINE('BEGIN','BEGIN');
DEFINE('ROLLBACK','ROLLBACK');
DEFINE('COMMIT','COMMIT');

include('lib/db/sqlLayer.inc.php');
include('lib/db/sqlDebug.inc.php');

class sqlConnect extends sqlLayer
{

	var $selectdb;
	var $getDbHost;
	var $getDbName;
	var $debug;

	var $Id;
	var $IdFreeResult = array();
	var $getResult;

	var $sqlRows;
	var $sqlNumFields;
	var $sqlFieldName;
	var $sqlLastQuery = array();
	var $sqlAffectedRows;

	var $beginOn;
	var $startCommit;

	/* {{{ loadDriver()
	 *
	 * Esttica 
	 *
	 * --------------------------------------------------
	 * Normalmente, este array vem de um arquivo config
	 * --------------------------------------------------
	 * $Conn = array(
	 *		'host'=>'localhost',
	 *		'port'=>'5432',
    *		'user'=>'user',
    *		'password'=>'pwd'
    *		'dbname'=>'nomebanco'
    * );
    *
    * $Db = Connect::loadDriver('pgsql',$Conn);
    *
	 * @param	(string) tipo de sgbd  pgsql ou mysql
	 * @param   (array)	valores para conexo
	*/
	function loadDriver($driver,$conn)
	{
		if(is_array($conn))
		{
			switch($driver)
			{
				case pgsql:
					foreach((array)$conn as $key => $value)
						$connect .= "$key=$value ";

				break;
				case mysql:
					$connect = $conn[host].":".$conn[user].":".$conn[password];
					$seldb = $conn[dbname];
				break;
			}
		
			return $obj =& new sqlConnect($driver,$seldb,$connect);
		}
		else
			sqlConnect::_sqlRaiseError(DB_ERROR_CONNECT_PARAM);
	}		  


	/*	{{{ Construtor
	 *
	 * @param	(string)	tipo de sgbd - mysql ou pgsql
	 * @param	(string)	nome do banco
    * @param   (array)	valores para conexo
   */
   function sqlConnect($driver,$db,$connect)
   {
		$this->dbType = $driver;
            
		/*
		 * Link de conexo
		 * Nome do host
		 * Nome do Banco
		*/
		if(!($this->conn = $this->connect($connect)))
			$this->_sqlRaiseError(DB_ERROR_CONNECT);

		$this->selectdb	= $db;
		$this->getDbHost  = $this->dbhost($this->conn);
		$this->getDbName  = $this->dbname($this->conn);
            
		/*
		 * Setando classe de debug
		*/
		$this->debug = new sqlDebug;

   }

	/* }}}
	 * {{{ sqlPrepare()
	 *
	 * @param	(string) query de sql
	 * @param	(array)	valores para campos
	 *
	 * @ex:
	 * $sql = "select * from foo where campoid='{0}' and campotxt='{1}'";
	 * $obj->sqlExecute($obj->sqlPrepare($sql,array(83,'Nome qualquery')));
	*/
   function sqlPrepare(&$Query,$arrayParam)
   {
		if(is_array($arrayParam))
		{
			foreach($arrayParam as $paramName)
      	{
         	if(is_int($arrayParam[$paramName]))
            	$arrayParam = (int)$arrayParam[$paramName];

         	if(is_numeric($arrayParam[$paramName]))
            	$arrayParam = (float)$arrayParam[$paramName];

         	if(is_string($arrayParam[$paramName]))
            	$arrayParam = (string) addslashes($arrayParam[$paramName]);

         	if(is_bool($arrayParam[$paramName]))
           		$arrayParam = (bool)$arrayParam[$paramName];
			}

			return preg_replace('/\{(.*?)\}/ei','$arrayParam[\'$1\']',$Query);
      }
		else
			$this->_sqlRaiseError(DB_ERROR_QUERY.' sqlPrepare (no  array)');
   }

   /* }}}
	 * {{{ sqlQuery()
	 *
    * Mtodo de execuo
    * @param   (string) instruo sql
    * @param   (bool) para ativar mtodo debug
   */
   function &sqlQuery($Query,$Debug=false)
   {
      /*
       * Armazena querys
       * Utilizadas para qualquer finalidade
      */
      $this->sqlLastQuery[] = $Query;

      if($Debug)
         die($this->sqlClose($this->debug->getQuery($Query)));

      if(!($exec = $this->query(trim($Query))))
         $this->_sqlRaiseError($this->sqlClose(DB_ERROR_QUERY));

      /*
       * Seta o parmetro Id armazenado em um array
       * para liberar no destrutor
      */
      $this->Id = &$exec;
      $this->IdFreeResult[] = $this->Id;

      if($this->debug->getTypeQuery($Query)=="select")
      {
         $this->sqlRows         = $this->numrows($this->Id);
         $this->sqlNumFields   = $this->numfields($this->Id);

         /*
          * Retorna nome dos campos em array
         */
         for($k=0;$k<$this->sqlNum_Fields;$k++)
            $this->sqlFieldName[] = $this->fieldname($this->Id, $k);
      }

      /*
       * Limpa querys
      */
      unset($Query);
   }

   /* }}}
	 * {{{ sqlExecuteSimpleQuery()
	 *
    * @param   (string) instruo sql
    * @param   (bool) para ativar mtodo debug
   */
   function &sqlExecuteSingleQuery($Query,$Debug=false)
   {
		$this->sqlQuery($Query,$Debug);
      return $this->getResult = $this->result($this->Id);
	}

	/* }}}
	 * {{{ sqlBlock()
	 *
	 * Mtodo para transaes
	 *
	 * @param   (string) instruo sql
	 * @param   (bool) veja sqlQuery()
	*/
	function sqlBlock($Query,$Debug)
	{
		if($Debug)
			die($this->sqlClose($this->debug->getQuery($Query)));
	
	   /*
	    * Inicia transao
	   */
	   if($this->Begin_On==FALSE)
	   {
	      if(!($this->query($this->Begin)))
         	$this->_sqlRaiseError($this->sqlClose(DB_ERROR_QUERY));
	
	      $this->beginOn = TRUE;
	   }
	
	   /*
	    * Verifica se transao foi iniciada
	   */
	   if($this->beginOn)
	   {
	      if(!($Block = $this->query($Query)))
	      {
	         $this->query($this->Rollback);
	         $this->beginOn = FALSE;
	 
         	$this->_sqlRaiseError($this->sqlClose(DB_ERROR_QUERY));
	      }
	      $this->startCommit         = TRUE;
	      $this->sqlAffectedRows   = $this->affectedrows($Block);
			
			if($this->debug->getTypeQuery($Query)=='insert')
			{
				switch($this->dbType)
				{
					case pgsql:
						if($this->getSeq())
						{
							$strQueryCurrval = "select currval('".$this->getSeq()."') as cval;";
							if(!($currval = $this->query($strQueryCurrval)))
         					$this->_sqlRaiseError($this->sqlClose(DB_ERROR_QUERY.' last_id'));
								
							$result_currval	= $this->result($currval);	
							$this->sqlLastId	= $result_currval['cval'];
						}
						else
							$this->sqlLastId = false;
					break;
					case mysql:
						$this->sqlLastId = $this->getId();
					break;
				}
			}
		}
	}
	
	
	/* }}}
	 * {{{ sqlAutoExecute()
	 * 
	 * @param	string	clausula sql (insert,update,delete)
	 * @param	string	nome da tabela
	 * @param	array		nome dos campos e valores (array associativo)
	 * @param	array		condies, (array associativo)
	 * @access	public
	*/
	function sqlAutoExecute($clausula='',$tabela='',$cmpvalue,$condicoes=false,$debug=false)
	{		
		switch(strtolower($clausula))
		{
			case 'update':
				foreach((array)$cmpvalue as $campos => $valores)
					$set .= "$campos='".addslashes($valores)."',";
				
				foreach((array)$condicoes as $awk => $awv)
					$cond .= "where $awk='".addslashes($awv)."' and";
				
				$strQueryUid  = "update $tabela ".substr($set,0,-1)." ";
				$strQueryUid .= substr(ereg_replace('andwhere','and',$cond),0,-4);
			break;
			case 'insert':
				foreach((array)$cmpvalue as $campos => $valores)
				{
					$into		.= "$campos,";
					$values	.= "'".addslashes($valores)."',";
				}
				
				$strQueryUid  = "insert into $tabela(".substr($into,0,-1).") ";
				$strQueryUid .= "values(".substr($values,0,-1).")";
			break;
         case 'delete':
            foreach((array)$condicoes as $campos => $valores)
               $cmpvlr  .= "where $campos='".addslashes($valores)."' and";

            $strQueryUid  = "delete from $tabela ";
            $strQueryUid .= substr(ereg_replace('andwhere','and',$cmpvlr),0,-4)."";
         break;
			
		}
		
		$this->sqlExecute($strQueryUid,$debug);
	}
	
	/* }}}
	 * {{{ setSeq()
	 * 
	 * @param	(string)		nome da sequencia
	 * 
	 * @access	public
	*/
	function setSeq($seqname="")
	{
		if(!($seqname))
         $this->_sqlRaiseError($this->sqlClose(DB_ERROR_QUERY.' Sequncia incorreta (no existe)'));
		else
			return $this->seqname = $seqname;
	}

	/* }}}
	 * {{{ getSeq()
	 * 
	 * @access	private
	*/
	function getSeq()
	{
		return $this->seqname;
	}
	
	/* }}}
	 * {{{ sqlExecute()
	 *
    * Mtodo de execuo
    *
    * @param   (string) instruo sql
    * @param   (bool) veja sqlQuery()
	 * @access	public
   */
   function sqlExecute($Query="", $Debug=false)
   {
      switch($this->debug->getTypeQuery($Query))
      {
         case 'select':  return $this->sqlQuery($Query,$Debug); break;
         case 'insert':  return $this->sqlBlock($Query,$Debug); break;
         case 'update':  return $this->sqlBlock($Query,$Debug); break;
         case 'delete':  return $this->sqlBlock($Query,$Debug); break;
      }
   }


   /* }}}
	 * {{{ sqlResult()
	 *
    * Mtodo para resultado
    * O parametro $this->FetchMode
    * esta setado no cDefines como 1, retornando assim
    * por default fetch_array. Outra opo  o fetch_object
    * setando o $this->FetchMode como 2
   */
   function sqlResult()
   {
      return $this->getResult = $this->result($this->Id);
   }

   /* }}}
	 * {{{ sqlFreeResult()
	 *
    * Libera memria
   */
   function sqlFreeResult($resource)
   {
      return $this->freeresult($resource);
   }

   /* }}}
	 * {{{ sqlClose()
	 *
    * Link para Destrutor
   */
   function sqlClose()
   {
		if($param = func_get_args())
			echo $param[0];
		call_user_func(array(&$this,'__sqlConnect'));
   }

   /* }}}
    * {{{ Destrutor
   */
   function __sqlConnect()
   {
      /*
       * Zera array das ultimas querys
      */
      unset($this->sqlLastQuery);

      /*
       * Executa sql_free_result
      */
      foreach((array)$this->IdFreeResult as $libera)
         $this->sqlFreeResult($libera);

      /*
       * Executa o commit quando
       * alguma transao for iniciada
       * Caso ocorra algum erro, retorna
       * rollback
      */
      if($this->StartCommit)
         if(!$this->query(COMMIT))
            $this->query(ROLLBACK);

      $this->close($this->conn);
		$this->conn = NULL;
   }

	/**
	 * }}}
	 * {{{ _sqlRaiseError()
	 */
	function _sqlRaiseError()
	{
		$args = func_get_args();
		die($args[0]."\n");
	}

	/* }}} */
}
?>
