<?php
/*
	+--------------------------------------------------+
	|Camada de abstrao - Verso para PHP4				|
	+--------------------------------------------------+
	|PostgreSQL														|
	|MySQL															|
	+--------------------------------------------------+
	|@autor   Juarez Gonalves Nery Junior					|
	|@email   jws_junior@yahoo.com.br						|
	|@HP      junior.t35.com									|
	|@data    Tue Mar 29 09:28:33 BRT 2005					|
	+--------------------------------------------------+
*/

class sqlLayer
{
   var $dbType;
	var $sqlFetchMode = 'ASSOC';
	var $conn;

   /* {{{ connect
	 *
    * Mtodo de conexo
    * @param   (string)
   */
   function connect($Conn)
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_connect($Conn);
         break;
         case mysql:
            list($host,$user,$pwd)=split(':',$Conn);
            return mysql_connect($host,$user,$pwd);
         break;
      }
   }

   /* }}}
	 * {{{ dbname()
	 *
    * Retorna nome do base de dados
   */
   function dbname()
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_dbname($this->conn);
         break;
         case mysql:
            return mysql_select_db($this->selectdb,$this->conn);
         break;
      }
   }

   /* }}}
	 * {{{ dbhost()
	 *
    * Retorna o host da base de dados
   */
   function dbhost()
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_host($this->conn);
         break;
         case mysql:
            return mysql_get_host_info($this->conn);
         break;
      }
   }

   /* }}}
	 * {{{ query()
	 *
    * Mtodo de execuo
    * @param   (string) instruo sql
    * @param   (resource) de conexo
   */
   function &query($Query)
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_query($this->conn,$Query);
         break;
         case mysql:
            return mysql_query($Query,$this->conn);
         break;
      }
   }

   /* }}}
	 * {{{ numrows()
	 *
    * @param   (resource) de sql
   */
   function numrows($Sql)
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_num_rows($Sql);
         break;
         case mysql:
            return mysql_num_rows($Sql);
         break;
      }
   }

   /* }}}
	 * {{{ numfields()
	 *
    * @param   (resource) de sql
   */
   function numfields($Sql)
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_num_fields($Sql);
         break;
         case mysql:
            return @mysql_num_fields($Sql);
         break;
      }
   }

   /* }}}
	 * {{{ fieldname()
	 *
    * @param   (resource) de sql
   */
   function fieldname($Sql,$point=0)
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_field_name($Sql,$point);
         break;
         case mysql:
            return @mysql_field_name($Sql,$point);
         break;
      }
   }

   /* }}}
	 * {{{ affectedrows()
	 *
    * @param   (resource) de sql
   */
   function affectedrows($Sql)
   {
      switch($this->dbType)
      {
         case pgsql:
            return pg_affected_rows($Sql);
         break;
         case mysql:
            return @mysql_affected_rows($Sql);
         break;
      }
   }

   /* }}}
    * {{{ getId()
    *
    * @param   (resource) de sql
   */
   function getId($Sql)
   {
      switch($this->dbType)
      {
         case mysql:
            return mysql_insert_id();
         break;
      }
   }

   /* }}}
	 * {{{ result()
	 *
    * @param   (resource) de execuo
   */
   function result($Sql)
   {
      switch ($this->dbType)
      {
         case pgsql:
            switch($this->sqlFetchMode)
            {
               case 'ASSOC':
                  return pg_fetch_assoc($Sql,NULL);
               break;
               case 'OBJECT':
                  return pg_fetch_object($Sql, NULL);
               break;
            }
         break;
         case mysql:
            switch($this->sqlFetchMode)
            {
               case 'ASSOC':
                  return mysql_fetch_assoc($Sql);
               break;
               case 'OBJECT':
                  return mysql_fetch_object($Sql);
               break;
            }
         break;
      }
   }

   /* }}}
	 * {{{ freeresult()
	 *
    * Libera memria
   */
   function freeresult(&$Id)
   {
      switch ($this->dbType)
      {
         case pgsql:
            return @pg_free_result($Id);
         break;
         case mysql:
            return @mysql_free_result($Id);
         break;
      }
   }

   /* }}}
	 * {{{ close()
	 *
    * close
    * @param   (resource) conexo
   */
   function close($Conn)
   {
      switch ($this->dbType)
      {
         case pgsql:
            return pg_close($Conn);
         break;
         case mysql:
            return @mysql_close($Conn);
         break;
      }
   }

	/* }}} */
}
?>
